#!/usr/local/bin/perl
#-------------------------------------------------------------------
# Change the location of perl on your server on the line above
#
# $cgi_dir  - url path to your cgi directory
# $my_url   - url path to this module
# $my_root  - path to the root web directory relative to the server root 
# require   - path to the library file relative to the server root 
#
# No other settings need to be changed.
#-------------------------------------------------------------------

$cgi_dir = "http://www.yourserver.com/cgi-bin";
$my_url = "http://www.yourserver.com/cgi-bin/lmadm.pl";
$my_root = "/home/myname/public_html";
require "/home/myname/cgi-bin/lmlib.pl";

#############################################################################
# ListMail CONFIGURATION MODULE
#
# This script handle the creation and maintainance of the ListMail
# configuration files.  ListMail allows for multiple lists, each with its
# own configuration file.  Administrators only need to point to the
# directory and name of the file to be created, everything else is 
# handled through menus and input forms.
#
# ListMail Setup:
# ---------------
# 1) Modify only the first line and path locations in all files
# 2) Place all script files into the cgi-bin directory.
# 3) Create a subdirectory for ListMail.
# 4) Create two subdirectories in the newly created ListMail directory.
#    Both directories must be world read and writable.
#       a) Files - Storage of data files used by the system.
#       b) Upload - temporary storage for uploaded files
# 5) Run this script to create and customize the ListMail for your needs.
#
# NOTE: All files for data and upload may be stored within the same
# subdirectory.  Keep in mind that all files within the directory can
# be accessed by users.  You may want to add a file named 'index.htm'
# to prevent users the ability to browse the contents of the directory.
#
# This script will allow for uploading of files from a computer to a server
# as well as handling subscriptions for the list. To use this you must be
# using a browser which supports RFC1867 protocol.  You may wish to visit 
# http://www.cis.ohio-state.edu/htbin/rfc/rfc1867.html to learn more about it.
#############################################################################
# COPYRIGHT NOTICE          Copyright 1998 P.M.Systems  All Rights Reserved.
#
# ListMail may be used and modified free of charge by anyone so long as
# this copyright notice and the comments above remain intact.  By using this
# code you agree to indemnify Paul Mele and P.M.Systems from any liability
# that might arise from it's use.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  In other words, please ask first before you try and
# make money off of my program.
#
# Obtain permission before redistributing this software over the Internet or
# in any other medium.  In all cases copyright and header must remain intact.
#
# Archived at: http://www.pmsys.com/software/    contact: webmaster@pmsys.com
##############################################################################
# HISTORY
#
# 1.00 - Initial Release
# 1.01 - Fixed bug that prevented proper setting of configuration settings.
# 1.10 - Added additional variables to be setup prior to executing  [10/15/98]
#
##############################################################################

#######################################################
# Initialize vars and parse input
#######################################################
$cfgdata = "/lmcfg.dat";
$VN = "1.10";
$| = 1;
$date = localtime(time);
$argcnt = &ParseInput;

#######################################################
# Get list configuration data
#######################################################
&ReadConfig;
@FILES=($COMPLIMENT_FILE,$CONFIRM_FILE,$MSG_FILE,$WELCOME_FILE,$VERIFY_FILE,$PRESEND_FILE,$LOG_MAIL,$LOG_SUBS);
@TITLES=("Complimentary Subscription","Confirmation","Mail Message","Welcome Message","Verification","Message Upload Notes","Mail","Subscription");
$FILESTART=0;
$LOGSTART=6;

#######################################################
# CGI system security checks
#######################################################
if (@AUTHORIZED_URLS) { &CheckReferer; }
&CheckIp;
&CheckUrl;

#######################################################
# Check for exit (really not used at this time)
#######################################################
if( $GLOBAL{'exit'} ) {
    if ( $RETURN_URL eq '' ) { $RETURN_URL="/index.htm"; }
    print "Location: $RETURN_URL\n\n";
}

#######################################################
# Nothing parsed means we are at the login menu
#######################################################
if ( !$argcnt || $GLOBAL{'login'} ) { &Login; }

#######################################################
# Check security to be sure no one is abusing system
#######################################################
&CheckUser;
&CheckEmail;

#######################################################
# Cfg file ops
#######################################################
if( $GLOBAL{'cfg_change'} ) { &ModifyConfig($GLOBAL{'section'}); }

#######################################################
# Edits for message files
#######################################################
if( $GLOBAL{'ed_compliment'} ) { &EditFile(($FILESTART + 0)); }
if( $GLOBAL{'ed_confirm'} ) { &EditFile(($FILESTART + 1)); }
if( $GLOBAL{'ed_msg'} ) { &EditFile(($FILESTART + 2)); }
if( $GLOBAL{'ed_welcome'} ) { &EditFile(($FILESTART + 3)); }
if( $GLOBAL{'ed_verify'} ) { &EditFile(($FILESTART + 4)); }
if( $GLOBAL{'ed_presend'} ) { &EditFile(($FILESTART + 5)); }
if( $GLOBAL{'save_file'} ) { &SaveFile($GLOBAL{'fnum'},$GLOBAL{'msgtext'}); }

#######################################################
# Uploads for message files
#######################################################
if( $GLOBAL{'up_compliment'} ) { &UploadForm(($FILESTART + 0)); }
if( $GLOBAL{'up_confirm'} ) { &UploadForm(($FILESTART + 1)); }
if( $GLOBAL{'up_msg'} ) { &UploadForm(($FILESTART + 2)); }
if( $GLOBAL{'up_welcome'} ) { &UploadForm(($FILESTART + 3)); }
if( $GLOBAL{'up_verify'} ) { &UploadForm(($FILESTART + 4)); }
if( $GLOBAL{'up_presend'} ) { &UploadForm(($FILESTART + 5)); }
if( $GLOBAL{'saveupload'} ) { &SaveUpload( $GLOBAL{'FILE_NAME'}, $GLOBAL{'fnum'}); }

#######################################################
# Log file viewing
#######################################################
if( $GLOBAL{'view_mail_log'} ) { &ViewFile(($LOGSTART + 0)); }
if( $GLOBAL{'view_subs_log'} ) { &ViewFile(($LOGSTART + 1)); }

#######################################################
# Log file removal
#######################################################
if( $GLOBAL{'clear_mail_log'} ) { &ClearFileVerify(($LOGSTART + 0)); }
if( $GLOBAL{'clear_subs_log'} ) { &ClearFileVerify(($LOGSTART + 1)); }
if( $GLOBAL{'clear_log_ok'} ) { &ClearFile($GLOBAL{'file'}); }

#######################################################
# Menus for verified admin
#######################################################
if( $GLOBAL{'general'} ) { &Menu_General; }
if( $GLOBAL{'custom'} ) { &Menu_Custom; }
if( $GLOBAL{'data'} ) { &Menu_File; }
if( $GLOBAL{'html'} ) { &Menu_Html; }
if( $GLOBAL{'logs'} ) { &Menu_Logs; }
if( $GLOBAL{'mail'} ) { &Menu_Mail; }
if( $GLOBAL{'security'} ) { &Menu_Security; }
&Menu;

#######################################################
# All done - we are outta here!
#######################################################
exit;



#######################################################
# Subroutine to check if password file exists and
# if it does then check for proper credentials.
#######################################################
sub CheckUser {

    my ( $tmp );

    # Does the password file exist?
    open(FILE, "$my_root$DATA_ROOT/$ADMIN_FILE") || return;
    close(FILE);

    # Password file exists so lets check them credentials
    &CheckParms($GLOBAL{'email'}, $GLOBAL{'password'});
    $email = $GLOBAL{'email'};
    $pass = $GLOBAL{'password'};
    if( $GLOBAL{'encrypt'} ) { $encrypt=1; }else{ $encrypt=0; }
    $tmp = $DATA_ROOT;
    $DATA_ROOT = "$my_root$DATA_ROOT";
    &VerifyUserPass(1);
    $DATA_ROOT = $tmp;
}

#######################################################
# Subroutine to verify clearing of log file
#######################################################
sub ClearFileVerify {

    my ( $fnum )=@_;

    # Verify the user wants to clear values as a precaution
    if ( $FILES[$fnum] eq '' ) { FileError($FILES[$fnum],"logs"); }
    &Header("$LIST_NAME $TITLES[$fnum] Log");
    print "<p>Please verify you wish to clear this file.</p>\n";
    print "<FORM METHOD='POST'><center>\n";
    print "<INPUT TYPE=submit NAME=clear_log_ok VALUE=' Clear '>\n";
    print "<INPUT TYPE=submit NAME=logs VALUE=' Cancel '>\n";
    print "<INPUT TYPE=hidden NAME=fnum VALUE=$fnum>\n";
    print "</center>\n";
    &WriteUserInfo;
    &Footer;
    exit;
}

#######################################################
# Subroutine to clear log file
#######################################################
sub ClearFile {

    my ( $fnum )=@_;

    # Open file for output and close it as empty
    open (FILE, ">$my_root$DATA_ROOT/$FILES[$fnum]");
    close(FILE);

    # Display results to user
    &Header("$LIST_NAME Clear $TITLES[$fnum] Log");
    print "<p>Log file has been cleared.</p>\n";
    print "<FORM METHOD='POST'><center>\n";
    print "<INPUT TYPE=submit NAME=logs VALUE=' Ok '>\n";
    print "</center>\n";
    &WriteUserInfo;
    &Footer;
    exit;
}

#######################################################
# Subroutine to allow editing of message files
#######################################################
sub EditFile {

    my ( $fnum )=@_;
    my ( $file, @list, $name, $tmp );

    # Open and input contents of message file
    if ( $FILES[$fnum] eq '' ) { FileError($FILES[$fnum],"custom"); }
    open(FILE, "$my_root$DATA_ROOT/$FILES[$fnum]");
    @list = <FILE>;
    close(FILE);
    $tmp = join('',@list);

    # Display edit form to user
    &Header("$LIST_NAME $TITLES[$fnum] File Edit");
    print "<p>Edit your message file as needed.  You may use any type of formatting you require. ";
    print "Text may be pasted directly into the message area using your browsers cut and paste functions.</p>\n";
    print "<FORM METHOD='POST'><center>\n";
    print "<TEXTAREA NAME=msgtext COLS=70 ROWS=15 WRAP=soft>$tmp</TEXTAREA>\n";
    print "<p> </p>\n";
    print "<INPUT TYPE=submit NAME=save_file VALUE='Submit'>\n";
    print "<INPUT TYPE=submit NAME=custom VALUE='Cancel'>\n";
    print "<INPUT TYPE=hidden NAME=fnum VALUE=$fnum>\n";
    print "</center>\n";
    &WriteUserInfo;
    &Footer;
    exit;
}

#######################################################
# Subroutine to inform user file has not
# been defined or could not be found
#######################################################
sub FileError {

    my($file, $rtn)=@_;

    &Header("File Error!");
    if ( $file ne '' ) {
        print "<p>The file '$file' could not be found.</p>\n";
    }
    else {
        print "<p>The specified file has not been defined.</p>\n";
    }
    print "<FORM METHOD='POST'><center>\n";
    print "<INPUT TYPE=submit NAME=$rtn VALUE=' Ok '>\n";
    print "</center>\n";
    &WriteUserInfo;
    &Footer;
    exit;
}

#######################################################
# Subroutine to login user
#######################################################
sub Login {

    # Require login only if the password file exists
    open(FILE, "$my_root$DATA_ROOT/$ADMIN_FILE") || return;
    close(FILE);

    # File exists, let's have them login
    &Header("$LIST_NAME");
    print "<FORM METHOD='POST'>\n";
    print "<p>Welcome to the $LIST_NAME Configuration Menu!  This menu is for administrators of $LIST_NAME only ";
    print "and has been password protected. You must enter both your username and password before selecting any available functions.</p>";
    print "<p><font size='+1'><i>Enter your Admin Name and Password:</i></font></p>\n";
    print "<table border='1' cellpadding='3' cellspacing='3' width='80%'>\n";
    print "<tr><td>\n";
    print "Admin Name: <INPUT TYPE=text NAME=email SIZE=30><BR>\n";
    print "</td><td>\n";
    print "Password: <INPUT TYPE=password NAME=password SIZE=10><BR>\n";
    print "</td></tr>\n";
    print "</table>\n";
    print "<table border='0' cellpadding='3' cellspacing='3' width='80%'>\n";
    print "<tr><td align='center' colspan='2'>\n";
    print "<INPUT TYPE=submit NAME=menu VALUE=' Enter '>\n";
    print "<p align='center'>[ <a href='$RETURN_URL'>Cancel</a> ]</p>\n";
    print "<INPUT TYPE=hidden NAME=cfg VALUE='$cfgdata'></FORM>\n";
    print "</td></tr>\n";
    print "</table>\n";
    print "</FORM>\n";
    &Footer;
    exit;
}

#######################################################
# Subroutines to display different menus to user
#######################################################
sub Menu {

    &Header("$LIST_NAME Configuration Settings");
    print "<center><FORM METHOD=POST>\n";
    print "<table border=1>\n";
    print "<tr><td colspan=2 align='center'>Configuration File: <INPUT TYPE=text NAME=cfgname VALUE='$cfgdata' SIZE=30>";
    print "<INPUT TYPE=submit NAME=getcfg VALUE='Retrieve'></td></tr>\n";
    print "<tr><td><INPUT TYPE=submit NAME=general VALUE='General Info'></td><td>\n";
    print "General system settings such as sendmail location, data file location and return URL.</td></tr>\n";
    print "<tr><td><INPUT TYPE=submit NAME=custom VALUE='Custom Msg'></td><td>\n";
    print "Customized message files for mailed messages, HTML welcome and subscription verification.</td></tr>\n";
    print "<tr><td><INPUT TYPE=submit NAME=data VALUE='File Names'></td><td>\n";
    print "Names assigned to data file for users, admin, and email addresses.</td></tr>\n";
    print "<tr><td><INPUT TYPE=submit NAME=html VALUE='HTML Tags'></td><td>\n";
    print "Specific settings for background images and color, text and link colors located in the body element of HTML pages generated by ListMail.</td></tr>\n";
    print "<tr><td><INPUT TYPE=submit NAME=logs VALUE='Log Files'></td><td>\n";
    print "Names of log files used to track $LIST_NAME usage along with list subscriptions and removals.</td></tr>\n";
    print "<tr><td><INPUT TYPE=submit NAME=mail VALUE='Mail  Pref'></td><td>\n";
    print "General mail preferences to allow binary uploading, Subject prefix, Confirmation message and subject heading.</td></tr>\n";
    print "<tr><td><INPUT TYPE=submit NAME=security VALUE='Security'></td><td>\n";
    print "$LIST_NAME security file names used to lock out specified URLs, email addresses, IP addresses and to specify authorized URLs for access to script.</td></tr>\n";
    print "<tr><td colspan=2>\n";
    print "<p align='center'>[ <a href='$RETURN_URL'>Exit</a> | \n";
    print "<a href='$cgi_dir/lmadm.pl?email=$email&password=$pass&encrypt=1&cfg=$cfgdata&menu=1'>List Administration</a> | \n";
    open (USER, "$my_root$DATA_ROOT/$USER_FILE");
    while (<USER>) {
        chop ($_);
        ($user_pass, $user_name) = split(/\|/, $_);
        if (lc($user_name) eq lc($email)) { last; }
    }
    close (USER);
    print "<a href='$cgi_dir/lmail.pl?email=$email&password=$user_pass&encrypt=1&cfg=$cfgdata&menu=1'>List Mail</a> ]</p>\n";
    print "<h5 align='center'><i>COPYRIGHT NOTICE: Copyright 1998 P.M. Systems  All Rights Reserved.</i></h5>\n";
    print "<font size=1>\n";
    print "ListMail may be used and modified free of charge by anyone so long as this copyright notice and \n";
    print "the comments remain intact.  By using this code you agree to indemnify P.M. Systems from any \n";
    print "liability that might arise from it's use. Selling the code for this program without prior written\n"; 
    print "consent is expressly forbidden.  In other words, please ask first before you try and make money \n";
    print "off of this program. Obtain permission before redistributing this software over the Internet or\n";
    print "in any other medium.  In all cases copyright and header must remain intact.\n";
    print "</font>\n";
    print "</td></tr>\n";
    print "</table>\n";
    print "</center>\n";
    &WriteUserInfo;
    print "</FORM>\n";
    &Footer;
    exit;
}
sub Menu_Custom {

    &Menu_Header("$LIST_NAME Custom Messages");
    print "<INPUT TYPE=hidden NAME=section VALUE=custom>\n";
    print "<font size=2><i>These files are all optional and can be customized to fit the needs of your list.</i></font></td></tr>\n";
    print "<tr><td>Complimentary subscription notification message to be mailed to the user after the administrator adds a Non-Member address. ListMail will automatically append an unsubscribe notice to the end of the message. <sup>(3)</sup>:</td>\n";
    print "<td><INPUT TYPE=text NAME=compliment_file SIZE=20 VALUE='$COMPLIMENT_FILE'><INPUT TYPE=submit NAME=ed_compliment VALUE='Edit'><INPUT TYPE=submit NAME=up_compliment VALUE='Upload'></td></tr>\n";
    print "<tr><td>Customized confirmation message to be mailed to the user after a successful subscription.  ListMail will automatically append the email address and password entered in the subscription form to the end of the message. <sup>(3)</sup>:</td>\n";
    print "<td><INPUT TYPE=text NAME=confirm_file SIZE=20 VALUE='$CONFIRM_FILE'><INPUT TYPE=submit NAME=ed_confirm VALUE='Edit'><INPUT TYPE=submit NAME=up_confirm VALUE='Upload'></td></tr>\n";
    print "<tr><td>Customized message to be appended to the end of all mailed messages from list members.  Usually contains information on how to unsubscribe from the list. <sup>(3)</sup>:</td>\n";
    print "<td><INPUT TYPE=text NAME=msg_file SIZE=20 VALUE='$MSG_FILE'><INPUT TYPE=submit NAME=ed_msg VALUE='Edit'><INPUT TYPE=submit NAME=up_msg VALUE='Upload'></td></tr>\n";
    print "<tr><td>Customized welcome message to be used after successful login to $LIST_NAME.  Used on the page containing the main menu and displayed at the top of the page.  Message can contain standard HTML tags where desired. <sup>(3)</sup>:</td>\n";
    print "<td><INPUT TYPE=text NAME=welcome_file SIZE=20 VALUE='$WELCOME_FILE'><INPUT TYPE=submit NAME=ed_welcome VALUE='Edit'><INPUT TYPE=submit NAME=up_welcome VALUE='Upload'></td></tr>\n";
    print "<tr><td>Secondary verification page displayed prior to successful subscription.  If defined, this is a customized html page, body only without <body> tags, to be used to for the user to verify he wants to be subscribed to the list. Can be used for additional warnings due to certain content. <sup>(3)</sup>:</td>\n";
    print "<td><INPUT TYPE=text NAME=verify_file SIZE=20 VALUE='$VERIFY_FILE'><INPUT TYPE=submit NAME=ed_verify VALUE='Edit'><INPUT TYPE=submit NAME=up_verify VALUE='Upload'></td></tr>\n";
    print "<tr><td>Message upload area notes. Displayed in the message upload form for additional warnings prior to sending messages to list members. <sup>(3)</sup>:</td>\n";
    print "<td><INPUT TYPE=text NAME=presend_file SIZE=20 VALUE='$PRESEND_FILE'><INPUT TYPE=submit NAME=ed_presend VALUE='Edit'><INPUT TYPE=submit NAME=up_presend VALUE='Upload'></td></tr>\n";
    &Menu_Footer;
}
sub Menu_File {

    &Menu_Header("$LIST_NAME File Names");
    print "<INPUT TYPE=hidden NAME=section VALUE=files>\n";
    print "<font size=2><i>In most if not all cases, the default names should be used</i></font></td></tr>\n";
    print "<tr><td>File used to hold all subscribed members passwords and email addresses. <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=user_file SIZE=35 VALUE='$USER_FILE'></td></tr>\n";
    print "<tr><td>File used to maintain additional unsubscribed email addresses which the List Administrator wants mail sent to.  Use when first setting up a list from another package or when there are already a number of email addresses aquired for a list.  As each member subscribes themself, their address will be removed from this list and placed into the user file along with their password. Maintain through the LMADM script. <sup>(2)(3)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=addr_file SIZE=35 VALUE='$ADDR_FILE'></td></tr>\n";
    &Menu_Footer;
}
sub Menu_General {

    &Menu_Header("$LIST_NAME General Info");
    print "<INPUT TYPE=hidden NAME=section VALUE=general>\n";
    print "<font size=2><i>System wide settings.</i></font></td></tr>\n";
    print "<tr><td>Name of mail list.  This name will be used on headings and mailings.</td>\n";
    print "<td><INPUT TYPE=text NAME=list_name SIZE=30 VALUE='$LIST_NAME'></td></tr>\n";
    print "<tr><td>Location of system mail program relative to server root directory.</td>\n";
    print "<td><INPUT TYPE=text NAME=mailprog SIZE=30 VALUE='$MAILPROG'></td></tr>\n";
    print "<tr><td>Directory where system data files will be stored. <sup>(1)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=data_root SIZE=30 VALUE='$TMP_DATA_ROOT'></td></tr>\n";
    print "<tr><td>List Administrator's email address for all list members questions and comments.</td>\n";
    print "<td><INPUT TYPE=text NAME=from SIZE=30 VALUE='$FROM'></td></tr>\n";
    print "<tr><td>Name of lock file. This file is used to lock user access while system files are being updated. <sup>(2)</sup>:</td>\n";
    print "<td><INPUT TYPE=text NAME=lock_file SIZE=30 VALUE='$LOCK_FILE'></td></tr>\n";
    &Menu_Footer;
}
sub Menu_Html {

    &Menu_Header("$LIST_NAME Html Tags");
    print "<INPUT TYPE=hidden NAME=section VALUE=html>\n";
    print "<font size=2><i>If an entry is left blank, the users' browser default settings will be used.<br>\n";
    print "Use either hex format '#000000' or alpha 'YELLOW'.</i></font></td></tr>\n";
    print "<tr><td>Background color</td>\n";
    print "<td><INPUT TYPE=text NAME=bgcolor SIZE=20 VALUE='$BGCOLOR'></td></tr>\n";
    print "<tr><td>Text color</td>\n";
    print "<td><INPUT TYPE=text NAME=textcolor SIZE=20 VALUE='$TEXTCOLOR'></td></tr>\n";
    print "<tr><td>Link color</td>\n";
    print "<td><INPUT TYPE=text NAME=link_color SIZE=20 VALUE='$LINK_COLOR'></td></tr>\n";
    print "<tr><td>Active link color</td>\n";
    print "<td><INPUT TYPE=text NAME=alink_color SIZE=20 VALUE='$ALINK_COLOR'></td></tr>\n";
    print "<tr><td>Visited link color</td>\n";
    print "<td><INPUT TYPE=text NAME=vlink_color SIZE=20 VALUE='$VLINK_COLOR'></td></tr>\n";
    print "<tr><td>Background Image <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=bgimage SIZE=20 VALUE='$BGIMAGE'></td></tr>\n";
    print "<tr><td>URL to return user after using the system.  <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=return_url SIZE=20 VALUE='$RETURN_URL'></td></tr>\n";
    print "<tr><td>URL for entry into the $LIST_NAME system.  Used for mail messages and unsubscribe notices to inform the user where to go to gain access to the list.  <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=entry_url SIZE=20 VALUE='$ENTRY_URL'></td></tr>\n";
    &Menu_Footer;
}
sub Menu_Logs {

    &Menu_Header("$LIST_NAME Log Files");
    print "<INPUT TYPE=hidden NAME=section VALUE=logs>\n";
    print "<font size=2><i>Log files are used to track system usage, \n";
    print "subscriptions and removals.These files are not automatically purged and will grow in size as time goes on.\n";
    print "Blank entries indicate no logs will be kept.</i></font></td></tr>\n";
    print "<tr><td>File used to track all mailings from list members.  Items tracked are: date, user, subject, recipients and attached file name if binaries files are allowed. <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=log_mail SIZE=25 VALUE='$LOG_MAIL'><INPUT TYPE=submit NAME=view_mail_log VALUE='View'><INPUT TYPE=submit NAME=clear_mail_log VALUE='Clear'></td></tr>\n";
    print "<tr><td>File used to log all users subscribing and unsubscribing from the list.  Items tracked are email address and passwords. <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=log_subs SIZE=25 VALUE='$LOG_SUBS'><INPUT TYPE=submit NAME=view_subs_log VALUE='View'><INPUT TYPE=submit NAME=clear_subs_log VALUE='Clear'></td></tr>\n";
    &Menu_Footer;
}
sub Menu_Mail {

    &Menu_Header("$LIST_NAME Mail Preferences");
    print "<INPUT TYPE=hidden NAME=section VALUE=mail>\n";
    print "<font size=2><i>These settings control how ListMail configures messages sent to list members.</i></font></td></tr>\n";
    print "<tr><td>Send copies of all subscription and unsubscribe notices to list administrator.</td>\n";
    print "<td><INPUT TYPE=checkbox NAME=send_bcc";
    if ( $SEND_BCC ne 0 ) { print " CHECKED"; }
    print "> Yes</td></tr>\n";
    print "<tr><td>Allow binary uploads.  If checked, please specify a world-writeable directory within your website to be used for temporary storage of uploaded files. <sup>(2)</sup><br><br><font size=2><i>Note, bandwidth will increase based on binary file sizes and number of list members.</i></font></td>\n";
    print "<td><INPUT TYPE=checkbox NAME=allow_upload";
    if ( $ALLOW_UPLOAD ne 0 ) { print " CHECKED"; }
    print "> Yes <INPUT TYPE=text NAME=upload_dir SIZE=28 VALUE='$UPLOAD_DIR'></td></tr>\n";
    print "<tr><td>Subject prefix to be used on all mailings from the list.</td>\n";
    print "<td><INPUT TYPE=text NAME=subj_prefix SIZE=35 VALUE='$SUBJ_PREFIX'></td></tr>\n";
    print "<tr><td>Confirmation subject to be used on all mailings for successful subcriptions to the list.</td>\n";
    print "<td><INPUT TYPE=text NAME=con_subj SIZE=35 VALUE='$CON_SUBJ'></td></tr>\n";
    print "<tr><td>Complimentary subscription Notification subject to be used on all mailings for successful subcriptions made for non-members by the list Administrator.</td>\n";
    print "<td><INPUT TYPE=text NAME=compliment_subj SIZE=35 VALUE='$COMPLIMENT_SUBJ'></td></tr>\n";
    &Menu_Footer;
}
sub Menu_Security {

    my ( $tmp );

    &Menu_Header("$LIST_NAME Security");
    print "<INPUT TYPE=hidden NAME=section VALUE=security>\n";
    print "<font size=2><i>In most if not all cases, the default names \n";
    print "should be used. These files are all maintained in the LMADM script.</i></font></td></tr>\n";
    print "<tr><td>Name of List Administrator's name and password file.  If  name is set the same as email address, the \n";
    print "administrator will be presented with an additional button for accessing the functions in \n";
    print "LMADM script when accessing $LIST_NAME user area. <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=admin_file SIZE=35 VALUE='$ADMIN_FILE'></td></tr>\n";
    print "<tr><td>Name of file used to hold unauthorized URLs. <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=url_file SIZE=35 value='$URL_FILE'></td></tr>\n";
    print "<tr><td>Name of file used to hold unauthorized IP Addresses. <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=ip_file SIZE=35 value='$IP_FILE'></td></tr>\n";
    print "<tr><td>Name of file used to hold unauthorized email addresses. <sup>(2)</sup></td>\n";
    print "<td><INPUT TYPE=text NAME=email_file SIZE=35 value='$EMAIL_FILE'></td></tr>\n";
    print "<tr><td>List of authorized URLs allowed to use the scripts.  At the very least your domain and url in http format should be used. Separate all entries using commas.</td>\n";
    $tmp = join(',',@AUTHORIZED_URLS);
    print "<td><INPUT TYPE=text NAME=authorized_urls SIZE=35 value='$tmp'></td></tr>\n";
    &Menu_Footer;
}
sub Menu_Header {

    my ($line) = @_;

    &Header($line);
    print "<FORM METHOD=POST><center>\n";
    print "<table border=1>\n";
    print "<tr><td colspan=2 align=center>\n";
}
sub Menu_Footer {

    print "<tr><td colspan=2>\n";
    print "<FONT SIZE=-1><B>NOTES:</B><br><i><pre>\n";
    print "(1) - Relative to root of web directory.\n";
    print "(2) - Files will be located in the specified data directory.\n";
    print "(3) - Optional, default messages will be used if left blank. \n";
    print "</pre></i></font>\n";
    print "</td></tr>\n";
    print "</table>\n";
    print "<p> </p>\n";
    print "<INPUT TYPE=submit NAME=cfg_change VALUE='Update'>\n";
    print "<INPUT TYPE=submit NAME=menu VALUE='Return'>\n";
    print "</center>\n";
    &WriteUserInfo;
    &Footer;
    exit;
}

#######################################################
# Subroutine to modify configuration information
#######################################################
sub ModifyConfig {

    my ( $section )=@_;
    my ( @list, $tmp, $cnt );

    # ----------------------------------------------------------------
    # Outputs new values set from input form based on section modified
    # ----------------------------------------------------------------
    # Custom files
    if ( $section eq 'custom' ) {
        $COMPLIMENT_FILE = SetConfigValue('compliment_file');
        $CONFIRM_FILE = SetConfigValue('confirm_file');
        $MSG_FILE = SetConfigValue('msg_file');
        $WELCOME_FILE = SetConfigValue('welcome_file');
        $VERIFY_FILE = SetConfigValue('verify_file');
        $PRESEND_FILE = SetConfigValue('presend_file');
    }
    # File name settings
    if ( $section eq 'files' ) {
        $USER_FILE = SetConfigValue('user_file');
        $ADDR_FILE = SetConfigValue('addr_file');
    }
    # General settings
    if ( $section eq 'general' ) {
        $LIST_NAME = SetConfigValue('list_name');
        $MAILPROG = SetConfigValue('mailprog');
        $TMP_DATA_ROOT = SetConfigValue('data_root');
        $FROM = SetConfigValue('from');
        $LOCK_FILE = SetConfigValue('lock_file');
    }
    # Html tags
    if ( $section eq 'html' ) {
        $BGCOLOR = SetConfigValue('bgcolor');
        $TEXTCOLOR = SetConfigValue('textcolor');
        $LINK_COLOR = SetConfigValue('link_color');
        $ALINK_COLOR = SetConfigValue('alink_color');
        $VLINK_COLOR = SetConfigValue('vlink_color');
        $BGIMAGE = SetConfigValue('bgimage');
        $RETURN_URL = SetConfigValue('return_url');
        $ENTRY_URL = SetConfigValue('entry_url');
    }
    # Log files
    if ( $section eq 'logs' ) {
        $LOG_MAIL = SetConfigValue('log_mail');
        $LOG_SUBS = SetConfigValue('log_subs');
    }
    # Mail preferences
    if ( $section eq 'mail' ) {
        if( $GLOBAL{'send_bcc'} && $GLOBAL{'send_bcc'} eq 'on' ) { $SEND_BCC = 1; }else{ $SEND_BCC = 0; }
        if( $GLOBAL{'allow_upload'} && $GLOBAL{'allow_upload'} eq 'on' ) { $ALLOW_UPLOAD = 1; }else{ $ALLOW_UPLOAD = 0; }
        $UPLOAD_DIR = SetConfigValue('upload_dir');
        $SUBJ_PREFIX = SetConfigValue('subj_prefix');
        $CON_SUBJ = SetConfigValue('con_subj');
        $COMPLIMENT_SUBJ = SetConfigValue('compliment_subj');
    }
    # Security items
    if ( $section eq 'security' ) {
        $ADMIN_FILE = SetConfigValue('admin_file');
        $URL_FILE = SetConfigValue('url_file');
        $IP_FILE = SetConfigValue('ip_file');
        $EMAIL_FILE = SetConfigValue('email_file');
        if( $GLOBAL{'authorized_urls'} ) {
            @list = split(/,/,$GLOBAL{'authorized_urls'});
            $cnt = 0;
            foreach $tmp (@list) {
                $tmp =~ s/\s*(.*?)\s*$/$1/;
                if ( $tmp ne '' ) {
                    $AUTHORIZED_URLS[$cnt] = $tmp;
                    $cnt++;
                }
            }
        }
    }

    # Output modified configuration to data file
    &WriteConfig;
}

#######################################################
# Subroutine to get list configuration data
#######################################################
sub ReadConfig {

    my ( @list, $newcfg );

    # Set current configuration file name
    if ( $GLOBAL{'cfg'} ) {
        $cfgdata = $GLOBAL{'cfg'};
        $argcnt--;
    }

    # Get new configuration file name if different
    $newcfg = 0;
    if ( $GLOBAL{'cfgname'} ) {
        if ( lc($cfgdata) ne lc($GLOBAL{'cfgname'}) ) {
            $cfgdata = $GLOBAL{'cfgname'};
            $newcfg = 1;
        }
    }

    # Read file and check if any data exists
    @list = ReadFile("$my_root$cfgdata");
    if ( @list ) {

        # Set current data from existing file
        require "$my_root$cfgdata";
    }
    else {

        # Set defaults values
        $COMPLIMENT_FILE = '';
        $CONFIRM_FILE = '';
        $MSG_FILE = '';
        $WELCOME_FILE = '';
        $VERIFY_FILE = '';
        $PRESEND_FILE = '';
        $USER_FILE = '';
        $ADDR_FILE = '';
        $LIST_NAME = 'Some List';
        $MAILPROG = '/usr/bin/sendmail';
        $TMP_DATA_ROOT = '/files';
        $FROM = 'webmaster\@yourdomain.com';
        $LOCK_FILE = 'lock.file';
        $BGCOLOR = '';
        $TEXTCOLOR = '';
        $LINK_COLOR = '';
        $ALINK_COLOR = '';
        $VLINK_COLOR = '';
        $BGIMAGE = '';
        $RETURN_URL = '/index.htm';
        $ENTRY_URL = '/index.htm';
        $LOG_MAIL = '';
        $LOG_SUBS = '';
        $SEND_BCC = 0;
        $ALLOW_UPLOAD = 1;
        $UPLOAD_DIR = '/upload';
        $SUBJ_PREFIX = '[ListMail]';
        $CON_SUBJ = '[ListMail] Confirmation';
        $COMPLIMENT_SUBJ = '[ListMail] Complimentary Subscription Notice';
        $ADMIN_FILE = 'admin.dat';
        $URL_FILE = 'url.dat';
        $IP_FILE = 'ip.dat';
        $EMAIL_FILE = 'email.dat';
        @AUTHORIZED_URLS = '';
    }
    $TMP_DATA_ROOT = $DATA_ROOT;

    # If we changed cfg, check to see if the password file exist
    if ( $newcfg ne 0 ) {
        open(FILE, "$my_root$DATA_ROOT/$ADMIN_FILE") || return;
        close(FILE);
        &Login;
    }
}

#######################################################
# Subroutine to save message file
#######################################################
sub SaveFile {

    my ( $fnum, $msg )=@_;

    # Open and output message file
    open(FILE, ">$my_root$DATA_ROOT/$FILES[$fnum]");
    print FILE "$msg";
    close(FILE);

    # Display results page
    &Header("$LIST_NAME $TITLES[$fnum] File Saved");
    print "<p>Your message file has been saved.</p>\n";
    print "<FORM METHOD='POST'><center>\n";
    print "<INPUT TYPE=submit NAME=custom VALUE=' Ok '>\n";
    print "</center>\n";
    &WriteUserInfo;
    &Footer;
    exit;
}

#######################################################
## Subroutine to save uploaded custom messages
#######################################################
sub SaveUpload {

    my ($file, $fnum) = @_;
    my ($remote_file, $file_stats, @status_list);

    # Upload file if we have one
    if ( $file eq '' ) { &Menu; }

    # Add our upload path to name of file
    $remote_file = "$my_root$DATA_ROOT/$FILES[$fnum]";

    # Upload message file from user
    &UploadFile($file,$remote_file);

    # Display results page
    &Header("$TITLES[$fnum] Message Upload Results");
    print "<P><PRE>";
    $file_stats = `ls -la $remote_file`;
    @status_list = split(/\s+/,  $file_stats);
    print "Remote File Name : <FONT COLOR=\#FF0000>$file</FONT>\n";
    print "File Name : $remote_file\n";
    print "File Size : $status_list[4]\n";
    print "Local Time: $status_list[5] $status_list[6] $status_list[7]\n";
    print "</PRE></P>";
    print "<p>Message file was successfully uploaded.</p>";
    print "<FORM METHOD=POST>\n";
    print "<INPUT TYPE=submit NAME=custom VALUE='Return'>\n";
    print "<INPUT TYPE=submit NAME=menu VALUE=' Menu '>\n";
    &WriteUserInfo;
    &Footer;
    exit;
}

#######################################################
# Subroutine to set configuration information
#######################################################
sub SetConfigValue {

    my ( $var )=@_;
    my ( $tmp );

    # Set return value based on incoming value
    if( $GLOBAL{$var} ) {
        $tmp = $GLOBAL{$var};
    }
    else {
        $tmp = '';
    }
    return ($tmp);
}

#######################################################
# Subroutine to display upload form to user
#######################################################
sub UploadForm {

    my($fnumtype)=@_;

    if ( $FILES[$fnum] eq '' ) { FileError($TITLES[$fnum],"custom"); }
    &Header("$TITLES[$fnum] File Upload");
    print "<P ALIGN='CENTER'>\n";
    print "<FORM METHOD=POST  ENCTYPE=multipart/form-data >\n";
    print "<table border='0' cellpadding='3' cellspacing='3' width='90%'>\n";
    print "<tr><td>File Name:</td>\n";
    print "<td><INPUT TYPE=file NAME=filename SIZE=35></td></tr>\n";
    print "<tr><td colspan='3' align='center'>\n";
    print "<BR><BR><INPUT TYPE=submit NAME=saveupload VALUE='Upload File'> \n";
    print "<INPUT TYPE=submit NAME=custom VALUE='Exit Upload'></td></tr>\n";
    print "</table>\n";
    print "<INPUT TYPE=hidden NAME=fnum VALUE=$fnum>\n";
    &WriteUserInfo;
    &Footer;
    exit;
}

#######################################################
# Subroutine to view log files
#######################################################
sub ViewFile {

    my ( $fnum )=@_;
    my ( @list, $clear, $tmp );

    # Read in file
    if ( $FILES[$fnum] eq '' ) { FileError($FILES[$fnum],"logs"); }
    open(FILE, "$my_root$DATA_ROOT/$FILES[$fnum]");
    @list = <FILE>;
    close(FILE);
    $tmp = join('',@list);

    &Header("$LIST_NAME $TITLES[$fnum] Log");
    print "<FORM METHOD='POST'><center>\n";
    print "<TEXTAREA COLS=70 ROWS=15>$tmp</TEXTAREA>\n";
    print "<p> </p>\n";
    print "<INPUT TYPE=submit NAME=logs VALUE=' Ok '>\n";
    if ($fnum eq $LOGSTART) { $clear = "clear_mail_log"; }
    if ($fnum eq ($LOGSTART + 1)) { $clear = "clear_subs_log"; }
    print "<INPUT TYPE=submit NAME=$clear VALUE='Clear'>\n";
    print "</center>\n";
    &WriteUserInfo;
    &Footer;
    exit;
}

#######################################################
# Subroutine to write configuration data
#######################################################
sub WriteConfig {

    my ( $tmp, $cnt );

    open(FILE, ">$my_root$cfgdata") || die "Could not open $cfgdata for output";
    print FILE "# ListMail Configuration File - Version $VN\n";
    print FILE "# Written: $date\n";
    print FILE "\n# Custom Message Files #\n";
    print FILE "\$COMPLIMENT_FILE='$COMPLIMENT_FILE';\n";
    print FILE "\$CONFIRM_FILE='$CONFIRM_FILE';\n";
    print FILE "\$MSG_FILE='$MSG_FILE';\n";
    print FILE "\$WELCOME_FILE='$WELCOME_FILE';\n";
    print FILE "\$VERIFY_FILE= '$VERIFY_FILE';\n";
    print FILE "\$PRESEND_FILE= '$PRESEND_FILE';\n";
    print FILE "\n# Files #\n";
    print FILE "\$USER_FILE='$USER_FILE';\n";
    print FILE "\$ADDR_FILE='$ADDR_FILE';\n";
    print FILE "\n# General Information #\n";
    print FILE "\$LIST_NAME='$LIST_NAME';\n";
    print FILE "\$MAILPROG='$MAILPROG';\n";
    print FILE "\$DATA_ROOT='$TMP_DATA_ROOT';\n";
    print FILE "\$FROM='$FROM';\n";
    print FILE "\$LOCK_FILE='$LOCK_FILE';\n";
    print FILE "\n# Html Tags #\n";
    print FILE "\$BGCOLOR='$BGCOLOR';\n";
    print FILE "\$TEXTCOLOR='$TEXTCOLOR';\n";
    print FILE "\$LINK_COLOR='$LINK_COLOR';\n";
    print FILE "\$ALINK_COLOR='$ALINK_COLOR';\n";
    print FILE "\$VLINK_COLOR='$VLINK_COLOR';\n";
    print FILE "\$BGIMAGE='$BGIMAGE';\n";
    print FILE "\$RETURN_URL='$RETURN_URL';\n";
    print FILE "\$ENTRY_URL='$ENTRY_URL';\n";
    print FILE "\n# Log Files #\n";
    print FILE "\$LOG_MAIL='$LOG_MAIL';\n";
    print FILE "\$LOG_SUBS='$LOG_SUBS';\n";
    print FILE "\n# Mail Preferences #\n";
    print FILE "\$SEND_BCC=$SEND_BCC;\n";
    print FILE "\$ALLOW_UPLOAD=$ALLOW_UPLOAD;\n";
    print FILE "\$UPLOAD_DIR='$UPLOAD_DIR';\n";
    print FILE "\$SUBJ_PREFIX='$SUBJ_PREFIX';\n";
    print FILE "\$CON_SUBJ='$CON_SUBJ';\n";
    print FILE "\$COMPLIMENT_SUBJ='$COMPLIMENT_SUBJ';\n";
    print FILE "\n# Security #\n";
    print FILE "\$ADMIN_FILE='$ADMIN_FILE';\n";
    print FILE "\$URL_FILE='$URL_FILE';\n";
    print FILE "\$IP_FILE='$IP_FILE';\n";
    print FILE "\$EMAIL_FILE='$EMAIL_FILE';\n";
    $cnt = 0;
    foreach $tmp (@AUTHORIZED_URLS) {
       $AUTHORIZED_URLS[$cnt] = "\"$tmp\"";
       $cnt++;
    }
    $tmp = join(',',@AUTHORIZED_URLS);
    print FILE "\@AUTHORIZED_URLS=($tmp);\n";
    print FILE "\n# End Of File #\n";
    close(FILE);

    # Redo our global array with any new values
    @FILES=($COMPLIMENT_FILE,$CONFIRM_FILE,$MSG_FILE,$WELCOME_FILE,$VERIFY_FILE,$PRESEND_FILE,$LOG_MAIL,$LOG_SUBS);
}

# end of script 
