#!/usr/local/bin/perl
#-------------------------------------------------------------------
# Change the location of perl on your server on the line above
#
# $cgi_dir  - url path to your cgi directory
# $my_url   - url path to this module
# $my_root  - path to the root web directory relative to the server root 
# require   - path to the library file relative to the server root 
#
# No other settings need to be changed.
#-------------------------------------------------------------------

$cgi_dir = "http://www.yourserver.com/cgi-bin";
$my_url = "http://www.yourserver.com/cgi-bin/lmadm.pl";
$my_root = "/home/myname/public_html";
require "/home/myname/cgi-bin/lmlib.pl";

#############################################################################
# File: wwwmail.pl 
# Date: April 28, 1998 
#############################################################################
# 
#############################################################################
# ListMail - Matt's WWWBOARD PLUGIN MODULE
#
# This script is designed to plug into Matt's WWWBoard.  This can be found at
#
# Copyright 1996 Matt Wright    mattw@worldwidemart.com
# Scripts Archive at:           http://www.worldwidemart.com/scripts/
#
# Using this plugin, all posts to the WWWBoard will also be mailed to
# all members of the list.  This allows members to stay in touch with
# postings without having to visit the board.  An added advantage is
# all members can contact all other members through ListMail without
# maintaining individual address lists.
#
# For ListMail setup, refer to the individual ListMail modules.
#
# ListMail Plugin Setup:
# ---------------------
# 1) Setup ListMail and configure as required.  Be sure it is
#    working properly before attempting to plugin this module.
# 2) Modify only the first line and path locations in all files
# 3) Open the WWWBoard module 'wwwboard.pl'.
# 4) Locate the line '&new_file;'.  This should be about 60 lines
#    into the module (using Version 2.0 ALPHA 2).  This should be
#    just before adding the new link to the wwwboard page and just
#    after parsing incoming variables.
# 5) Add the following lines just after the line found in the
#    previous step:
#
#       # Added for ListMail
#       require "$ENV{DOCUMENT_ROOT}/your-cgi/lmlib.pl";
#       require "$ENV{DOCUMENT_ROOT}/your-cgi/wwwmail.pl";
#       &WWWMail("cfg_file","user\@domain","user_pass","on");
#
#       NOTES:
#       a) Replace 'your-cgi' with the name of your cgi-bin directory.
#       b) Replace 'cfg_file' with the path and name of your
#          configuration file for the list.  This is relative to
#          the root of your web directory.
#       c) Replace 'user\@domain' with a valid email address belonging
#          to the list. Be sure to precede the @ symbol with a backslash.
#       d) Replace 'user_pass' with the appropriate password for the
#          user_name provided.  This password is not encrypted.
#       e) The "on" argument allows a copy of the posting to be sent
#          to the user defined.  Without this, the user defined in the
#          subroutine arguments would not receive a copy of the post.
#############################################################################
# COPYRIGHT NOTICE          Copyright 1998 P.M.Systems  All Rights Reserved.
#
# ListMail may be used and modified free of charge by anyone so long as
# this copyright notice and the comments above remain intact.  By using this
# code you agree to indemnify Paul Mele and P.M.Systems from any liability
# that might arise from it's use.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  In other words, please ask first before you try and
# make money off of my program.
#
# Obtain permission before redistributing this software over the Internet or
# in any other medium.  In all cases copyright and header must remain intact.
#
# Version 1.10  10/15/98
#    - Added additional variables to be setup prior to executing
#
# Archived at: http://www.pmsys.com/software/    contact: webmaster@pmsys.com
##############################################################################
# HISTORY
#
# 1.00 - Initial Release
# 1.10 - Added additional variables to be setup prior to executing  [10/15/98]
##############################################################################

$| = 1;

sub WWWMail {

    my ($cfgdata, $user, $pwd, $cc) = @_;
    my ($my_root, $comment, @comment, $match);

    #######################################################
    # Get list configuration data
    #######################################################
    open (TEST, "$cfgdata") || die "Can't open config file $cfgdata.";
    close (TEST);
    require $cfgdata;
    if ($DATA_ROOT ne '' ) { $DATA_ROOT = $my_root.$DATA_ROOT; }
    
    #######################################################
    # swap email and user due to conflict between scripts
    #######################################################
    $comment = $user;
    $user = $email;
    $email = $comment;
    $pass = $pwd;

    #######################################################
    # security checks
    #######################################################
    if (@AUTHORIZED_URLS) { &CheckReferer; }
    &CheckIp;
    &CheckUrl;
    &VerifyUserPass;

    #######################################################
    # output contents of message to be sent
    #######################################################
    open (NEWFILE, ">$my_root$UPLOAD_DIR/TmpFile") || die "Can't open tmp file for output [WWWMail]";
    print NEWFILE "Message:$baseurl/$mesgdir/$num\.$ext Posted by ";
    if ($user) { print NEWFILE "<$user>"; }
    print NEWFILE "$name on $long_date:\n\n";

    if ($followup == 1) {
       print NEWFILE "In Reply to: <$baseurl/$mesgdir/$last_message\.$ext>$origsubject posted by ";
       if ($origemail) { print NEWFILE "<$origemail>"; }
       print NEWFILE "$origname on $origdate:\n\n";
    }

    if ($message_img) { print NEWFILE "<img src=\"$message_img\">\n\n"; }
    $comment = $body;
    $comment =~ s/<p>/\n/gim;
    $comment =~ s/<br>/\n/gim;

    print NEWFILE "$comment\n\n";
    close(NEWFILE);

    #######################################################
    # Reopen message file, input contents and remove
    #######################################################
    open (NEWFILE, "$my_root$UPLOAD_DIR/TmpFile");
    @comment=<NEWFILE>;
    close(NEWFILE);
    unlink("$my_root$UPLOAD_DIR/TmpFile");
    $comment = join('',@comment);

    #######################################################
    # Go to it and send it out.  Return cnt is number of
    # list members the post was mailed to.
    #######################################################
    $cnt = &DoMailList('', '', $cc, "[Post] $subject", $comment);

    #######################################################
    # swap email and user back to previous values and exit
    #######################################################
    $comment = $user;
    $user = $email;
    $email = $comment;
}

# end of script
1; #return true 
